/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the PolicyCheckRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PolicyCheckRequest{}

// PolicyCheckRequest struct for PolicyCheckRequest
type PolicyCheckRequest struct {
	Script              string              `json:"script"`
	PolicyOperationType PolicyOperationType `json:"policyOperationType"`
	Model               interface{}         `json:"model"`
	UpdatedModel        interface{}         `json:"updatedModel,omitempty"`
	MethodName          string              `json:"methodName"`
}

type _PolicyCheckRequest PolicyCheckRequest

// NewPolicyCheckRequest instantiates a new PolicyCheckRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPolicyCheckRequest(script string, policyOperationType PolicyOperationType, model interface{}, methodName string) *PolicyCheckRequest {
	this := PolicyCheckRequest{}
	this.Script = script
	this.PolicyOperationType = policyOperationType
	this.Model = model
	this.MethodName = methodName
	return &this
}

// NewPolicyCheckRequestWithDefaults instantiates a new PolicyCheckRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPolicyCheckRequestWithDefaults() *PolicyCheckRequest {
	this := PolicyCheckRequest{}
	return &this
}

// GetScript returns the Script field value
func (o *PolicyCheckRequest) GetScript() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Script
}

// GetScriptOk returns a tuple with the Script field value
// and a boolean to check if the value has been set.
func (o *PolicyCheckRequest) GetScriptOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Script, true
}

// SetScript sets field value
func (o *PolicyCheckRequest) SetScript(v string) {
	o.Script = v
}

// GetPolicyOperationType returns the PolicyOperationType field value
func (o *PolicyCheckRequest) GetPolicyOperationType() PolicyOperationType {
	if o == nil {
		var ret PolicyOperationType
		return ret
	}

	return o.PolicyOperationType
}

// GetPolicyOperationTypeOk returns a tuple with the PolicyOperationType field value
// and a boolean to check if the value has been set.
func (o *PolicyCheckRequest) GetPolicyOperationTypeOk() (*PolicyOperationType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PolicyOperationType, true
}

// SetPolicyOperationType sets field value
func (o *PolicyCheckRequest) SetPolicyOperationType(v PolicyOperationType) {
	o.PolicyOperationType = v
}

// GetModel returns the Model field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *PolicyCheckRequest) GetModel() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.Model
}

// GetModelOk returns a tuple with the Model field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolicyCheckRequest) GetModelOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Model) {
		return nil, false
	}
	return &o.Model, true
}

// SetModel sets field value
func (o *PolicyCheckRequest) SetModel(v interface{}) {
	o.Model = v
}

// GetUpdatedModel returns the UpdatedModel field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolicyCheckRequest) GetUpdatedModel() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.UpdatedModel
}

// GetUpdatedModelOk returns a tuple with the UpdatedModel field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolicyCheckRequest) GetUpdatedModelOk() (*interface{}, bool) {
	if o == nil || IsNil(o.UpdatedModel) {
		return nil, false
	}
	return &o.UpdatedModel, true
}

// HasUpdatedModel returns a boolean if a field has been set.
func (o *PolicyCheckRequest) HasUpdatedModel() bool {
	if o != nil && !IsNil(o.UpdatedModel) {
		return true
	}

	return false
}

// SetUpdatedModel gets a reference to the given interface{} and assigns it to the UpdatedModel field.
func (o *PolicyCheckRequest) SetUpdatedModel(v interface{}) {
	o.UpdatedModel = v
}

// GetMethodName returns the MethodName field value
func (o *PolicyCheckRequest) GetMethodName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MethodName
}

// GetMethodNameOk returns a tuple with the MethodName field value
// and a boolean to check if the value has been set.
func (o *PolicyCheckRequest) GetMethodNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MethodName, true
}

// SetMethodName sets field value
func (o *PolicyCheckRequest) SetMethodName(v string) {
	o.MethodName = v
}

func (o PolicyCheckRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PolicyCheckRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["script"] = o.Script
	toSerialize["policyOperationType"] = o.PolicyOperationType
	if o.Model != nil {
		toSerialize["model"] = o.Model
	}
	if o.UpdatedModel != nil {
		toSerialize["updatedModel"] = o.UpdatedModel
	}
	toSerialize["methodName"] = o.MethodName
	return toSerialize, nil
}

func (o *PolicyCheckRequest) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"script",
		"policyOperationType",
		"model",
		"methodName",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varPolicyCheckRequest := _PolicyCheckRequest{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varPolicyCheckRequest)

	if err != nil {
		return err
	}

	*o = PolicyCheckRequest(varPolicyCheckRequest)

	return err
}

type NullablePolicyCheckRequest struct {
	value *PolicyCheckRequest
	isSet bool
}

func (v NullablePolicyCheckRequest) Get() *PolicyCheckRequest {
	return v.value
}

func (v *NullablePolicyCheckRequest) Set(val *PolicyCheckRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePolicyCheckRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePolicyCheckRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePolicyCheckRequest(val *PolicyCheckRequest) *NullablePolicyCheckRequest {
	return &NullablePolicyCheckRequest{value: val, isSet: true}
}

func (v NullablePolicyCheckRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePolicyCheckRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
